package cn.com.qmth.print.manage.controller;

import cn.com.qmth.print.manage.service.ExamStudentService;
import cn.com.qmth.print.manage.service.query.ExamStudentQuery;
import cn.com.qmth.print.manage.utils.PathUtil;
import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.IOException;

/**
 * @Date: 2021/11/16.
 */
@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/student")
@Aac(strict = false, auth = true)
public class ExamStudentController extends BaseController {

    @Resource
    private ExamStudentService examStudentService;

    /**
     * 导入考生数据
     *
     * @return
     */
    @RequestMapping(value = "/import", method = RequestMethod.POST)
    public Object importFile(@RequestParam Long examId, @RequestParam MultipartFile file) throws IOException {
        return examStudentService.analyzeZipAndImportStudents(examId, file);
    }

    /**
     * 导出云阅卷考生数据
     *
     * @param response response
     * @param examId   考试id
     * @throws IOException 异常
     */
    @RequestMapping(value = "/export", method = RequestMethod.POST)
    public void exportExamStudent(HttpServletResponse response, @RequestParam("examId") Long examId) throws IOException {
        examStudentService.exportExamStudent(response, examId);
    }

    /**
     * 分页考生详情
     *
     * @return
     */
    @RequestMapping(value = "/detail", method = RequestMethod.POST)
    public Object studentDetail(@Validated ExamStudentQuery query) {
        return examStudentService.pageStudent(query);
    }

    @GetMapping("/template")
    public void getImportTemplate() {
        String resoucePath = PathUtil.getResoucePath("importtemplates/studentImportTemplate.xlsx");
        exportFile("考生导入模板.xlsx", new File(resoucePath));
    }
}
